/*
this is part of brot_core.dll, a fractal generation library
Copyright (C) 2003 Rolf Neuberger

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
changes:
03/Mar-05 * added proper LGPL notice, started changelog - Rolf

*/

class
BoxedGenerator : public Generator
{
private:
	BoxedGenerator();	//hide default constructor
public:
	BoxedGenerator(Fractal* fractal);
	virtual ~BoxedGenerator() {};

	virtual bool refine_image(float max_time);
	virtual void reset();
	virtual float get_progress();
private:
	//subsection storage
	std::deque <Section> sections;
	uint filled_samples;
};
