;this is part of brot_core.dll, a fractal generation library
;Copyright (C) 2003 Rolf Neuberger
;
;This library is free software; you can redistribute it and/or
;modify it under the terms of the GNU Lesser General Public
;License as published by the Free Software Foundation; either
;version 2.1 of the License, or (at your option) any later version.
;
;This library is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;Lesser General Public License for more details.
;
;You should have received a copy of the GNU Lesser General Public
;License along with this library; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

SECTION .text

global _x86_get_timestamp
global _x86_subtract_timestamps

_x86_get_timestamp:
	PUSH EAX
	PUSH EDX
	PUSH ESI
	MOV ESI,[ESP+16]
	RDTSC
	MOV [ESI],EAX
	MOV [ESI+4],EDX
	POP ESI
	POP EDX
	POP EAX
	RETN

_x86_subtract_timestamps:
	PUSH EAX
	PUSH EDX
	PUSH ESI
	PUSH EDI
	MOV ESI,[ESP+20]
	MOV EDI,[ESP+24]
	SUB ESP,8
	MOV EAX,[ESI]
	MOV EDX,[ESI+4]
	SUB EAX,[EDI]
	SBB EDX,[EDI+4]
	MOV [ESP],EAX
	MOV [ESP+4],EDX
	FILD qword [ESP]
	ADD ESP,8
	POP EDI
	POP ESI
	POP EDX
	POP EAX
	RETN
